<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/CapabilityAgents/SpeakerManager/src/SpeakerManager.cpp File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7cf910bd1d7603f12ef47ff650cec893.html">CapabilityAgents</a></li><li class="navelem"><a class="el" href="dir_bc46a16e1ec7aec8565980dcd59aba5c.html">SpeakerManager</a></li><li class="navelem"><a class="el" href="dir_442b93685f9da00927e786b83e62ebb1.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#namespaces">Namespaces</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">SpeakerManager.cpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;rapidjson/document.h&gt;</code><br />
<code>#include &lt;rapidjson/stringbuffer.h&gt;</code><br />
<code>#include &lt;rapidjson/writer.h&gt;</code><br />
<code>#include &lt;rapidjson/error/en.h&gt;</code><br />
<code>#include &lt;<a class="el" href="_capability_configuration_8h_source.html">AVSCommon/AVS/CapabilityConfiguration.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_speaker_constants_8h_source.html">AVSCommon/AVS/SpeakerConstants/SpeakerConstants.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_j_s_o_n_utils_8h_source.html">AVSCommon/Utils/JSON/JSONUtils.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_logger_8h_source.html">AVSCommon/Utils/Logger/Logger.h</a>&gt;</code><br />
<code>#include &quot;<a class="el" href="_speaker_manager_constants_8h_source.html">SpeakerManager/SpeakerManagerConstants.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="_speaker_manager_8h_source.html">SpeakerManager/SpeakerManager.h</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for SpeakerManager.cpp:</div>
<div class="dyncontent">
<div class="center"><img src="_speaker_manager_8cpp__incl.png" border="0" usemap="#_2workplace_2avs-device-sdk_2_capability_agents_2_speaker_manager_2src_2_speaker_manager_8cpp" alt=""/></div>
<map name="_2workplace_2avs-device-sdk_2_capability_agents_2_speaker_manager_2src_2_speaker_manager_8cpp" id="_2workplace_2avs-device-sdk_2_capability_agents_2_speaker_manager_2src_2_speaker_manager_8cpp">
<area shape="rect" id="node6" href="_capability_configuration_8h.html" title="AVSCommon/AVS/Capability\lConfiguration.h" alt="" coords="3868,365,4061,404"/>
<area shape="rect" id="node9" href="_speaker_constants_8h.html" title="AVSCommon/AVS/SpeakerConstants\l/SpeakerConstants.h" alt="" coords="5,105,249,144"/>
<area shape="rect" id="node11" href="_j_s_o_n_utils_8h.html" title="AVSCommon/Utils/JSON\l/JSONUtils.h" alt="" coords="760,105,930,144"/>
<area shape="rect" id="node14" href="_logger_8h.html" title="AVSCommon/Utils/Logger\l/Logger.h" alt="" coords="1306,279,1482,317"/>
<area shape="rect" id="node28" href="_speaker_manager_constants_8h.html" title="SpeakerManager/SpeakerManager\lConstants.h" alt="" coords="4680,192,4910,231"/>
<area shape="rect" id="node30" href="_speaker_manager_8h.html" title="SpeakerManager/SpeakerManager.h" alt="" coords="2795,199,3035,224"/>
<area shape="rect" id="node12" href="_logger_utils_8h.html" title="AVSCommon/Utils/Logger\l/LoggerUtils.h" alt="" coords="1306,192,1482,231"/>
<area shape="rect" id="node19" href="_configuration_node_8h.html" title="AVSCommon/Utils/Configuration\l/ConfigurationNode.h" alt="" coords="1556,365,1770,404"/>
<area shape="rect" id="node23" href="_level_8h.html" title="AVSCommon/Utils/Logger\l/Level.h" alt="" coords="1314,452,1490,491"/>
<area shape="rect" id="node24" href="_log_entry_8h.html" title="AVSCommon/Utils/Logger\l/LogEntry.h" alt="" coords="983,365,1159,404"/>
<area shape="rect" id="node26" href="_log_level_observer_interface_8h.html" title="AVSCommon/Utils/Logger\l/LogLevelObserverInterface.h" alt="" coords="1234,365,1431,404"/>
<area shape="rect" id="node27" href="_sink_observer_interface_8h.html" title="AVSCommon/Utils/Logger\l/SinkObserverInterface.h" alt="" coords="2917,365,3093,404"/>
<area shape="rect" id="node25" href="_log_entry_stream_8h.html" title="AVSCommon/Utils/Logger\l/LogEntryStream.h" alt="" coords="1063,452,1239,491"/>
<area shape="rect" id="node29" href="_namespace_and_name_8h.html" title="AVSCommon/AVS/NamespaceAnd\lName.h" alt="" coords="5043,452,5273,491"/>
<area shape="rect" id="node34" href="_a_v_s_directive_8h.html" title="AVSCommon/AVS/AVSDirective.h" alt="" coords="3183,285,3405,311"/>
<area shape="rect" id="node38" href="_capability_agent_8h.html" title="AVSCommon/AVS/Capability\lAgent.h" alt="" coords="4188,279,4381,317"/>
<area shape="rect" id="node43" href="_capability_configuration_interface_8h.html" title="AVSCommon/SDKInterfaces\l/CapabilityConfigurationInterface.h" alt="" coords="2642,279,2868,317"/>
<area shape="rect" id="node44" href="_context_manager_interface_8h.html" title="AVSCommon/SDKInterfaces\l/ContextManagerInterface.h" alt="" coords="4795,279,4985,317"/>
<area shape="rect" id="node45" href="_message_sender_interface_8h.html" title="AVSCommon/SDKInterfaces\l/MessageSenderInterface.h" alt="" coords="3805,279,3996,317"/>
<area shape="rect" id="node46" href="_speaker_interface_8h.html" title="AVSCommon/SDKInterfaces\l/SpeakerInterface.h" alt="" coords="2024,452,2215,491"/>
<area shape="rect" id="node47" href="_speaker_manager_interface_8h.html" title="AVSCommon/SDKInterfaces\l/SpeakerManagerInterface.h" alt="" coords="2249,279,2440,317"/>
<area shape="rect" id="node48" href="_speaker_manager_observer_interface_8h.html" title="AVSCommon/SDKInterfaces\l/SpeakerManagerObserverInterface.h" alt="" coords="1997,365,2242,404"/>
<area shape="rect" id="node49" href="_requires_shutdown_8h.html" title="AVSCommon/Utils/Requires\lShutdown.h" alt="" coords="3429,279,3617,317"/>
<area shape="rect" id="node50" href="_executor_8h.html" title="AVSCommon/Utils/Threading\l/Executor.h" alt="" coords="2963,279,3158,317"/>
<area shape="rect" id="node36" href="_attachment_manager_interface_8h.html" title="Attachment/AttachmentManager\lInterface.h" alt="" coords="2680,365,2892,404"/>
<area shape="rect" id="node37" href="_a_v_s_message_8h.html" title="AVSMessage.h" alt="" coords="3581,372,3693,397"/>
<area shape="rect" id="node39" href="_exception_encountered_sender_interface_8h.html" title="AVSCommon/SDKInterfaces\l/ExceptionEncounteredSenderInterface.h" alt="" coords="4236,365,4501,404"/>
<area shape="rect" id="node40" href="_channel_observer_interface_8h.html" title="AVSCommon/SDKInterfaces\l/ChannelObserverInterface.h" alt="" coords="4526,365,4718,404"/>
<area shape="rect" id="node41" href="_context_requester_interface_8h.html" title="AVSCommon/SDKInterfaces\l/ContextRequesterInterface.h" alt="" coords="4792,365,4988,404"/>
<area shape="rect" id="node42" href="_state_provider_interface_8h.html" title="AVSCommon/SDKInterfaces\l/StateProviderInterface.h" alt="" coords="5063,365,5253,404"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr class="memitem:namespacealexa_client_s_d_k"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></td></tr>
<tr class="memdesc:namespacealexa_client_s_d_k"><td class="mdescLeft">&#160;</td><td class="mdescRight">Whether or not curl logs should be emitted. <br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1capability_agents"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents.html">alexaClientSDK::capabilityAgents</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html">alexaClientSDK::capabilityAgents::speakerManager</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:ad8bc9ca8e55a0ebf538e46e28bf26262"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_speaker_manager_8cpp.html#ad8bc9ca8e55a0ebf538e46e28bf26262">LX</a>(event)&#160;&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">alexaClientSDK::avsCommon::utils::logger::LogEntry</a>(<a class="el" href="_u_i_manager_8cpp.html#ada5473a95becdcf63a8f83e7f05fefe7">TAG</a>, event)</td></tr>
<tr class="separator:ad8bc9ca8e55a0ebf538e46e28bf26262"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ac8dcdcb036a00615ef8b5652254bc25c"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:ac8dcdcb036a00615ef8b5652254bc25c"><td class="memTemplItemLeft" align="right" valign="top">static bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html#ac8dcdcb036a00615ef8b5652254bc25c">alexaClientSDK::capabilityAgents::speakerManager::withinBounds</a> (T value, T min, T max)</td></tr>
<tr class="separator:ac8dcdcb036a00615ef8b5652254bc25c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad1e5526da4f88815d1f97dea9529602c"><td class="memItemLeft" align="right" valign="top">static std::shared_ptr&lt; avsCommon::avs::CapabilityConfiguration &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html#ad1e5526da4f88815d1f97dea9529602c">alexaClientSDK::capabilityAgents::speakerManager::getSpeakerCapabilityConfiguration</a> ()</td></tr>
<tr class="separator:ad1e5526da4f88815d1f97dea9529602c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a0d0eed77ae9aad6f0c9f20cf590c2b6f"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html#a0d0eed77ae9aad6f0c9f20cf590c2b6f">alexaClientSDK::capabilityAgents::speakerManager::SPEAKER_CAPABILITY_INTERFACE_TYPE</a> = &quot;AlexaInterface&quot;</td></tr>
<tr class="separator:a0d0eed77ae9aad6f0c9f20cf590c2b6f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a706982c5cb8d90697c54d164d40a5d2e"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html#a706982c5cb8d90697c54d164d40a5d2e">alexaClientSDK::capabilityAgents::speakerManager::SPEAKER_CAPABILITY_INTERFACE_NAME</a> = &quot;Speaker&quot;</td></tr>
<tr class="memdesc:a706982c5cb8d90697c54d164d40a5d2e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Speaker interface name.  <a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html#a706982c5cb8d90697c54d164d40a5d2e">More...</a><br /></td></tr>
<tr class="separator:a706982c5cb8d90697c54d164d40a5d2e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0dbcac71a8e2111776065fa2070fbaf1"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html#a0dbcac71a8e2111776065fa2070fbaf1">alexaClientSDK::capabilityAgents::speakerManager::SPEAKER_CAPABILITY_INTERFACE_VERSION</a> = &quot;1.0&quot;</td></tr>
<tr class="memdesc:a0dbcac71a8e2111776065fa2070fbaf1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Speaker interface version.  <a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html#a0dbcac71a8e2111776065fa2070fbaf1">More...</a><br /></td></tr>
<tr class="separator:a0dbcac71a8e2111776065fa2070fbaf1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a90a7290dd751d5a441bfc0073f8a828f"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html#a90a7290dd751d5a441bfc0073f8a828f">alexaClientSDK::capabilityAgents::speakerManager::TAG</a> {&quot;SpeakerManager&quot;}</td></tr>
<tr class="memdesc:a90a7290dd751d5a441bfc0073f8a828f"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html#a90a7290dd751d5a441bfc0073f8a828f">More...</a><br /></td></tr>
<tr class="separator:a90a7290dd751d5a441bfc0073f8a828f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f83881f9acd476313c652f53b57d7cc"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html#a1f83881f9acd476313c652f53b57d7cc">alexaClientSDK::capabilityAgents::speakerManager::SPEAKERMANAGER_CONFIGURATION_ROOT_KEY</a> = &quot;speakerManagerCapabilityAgent&quot;</td></tr>
<tr class="memdesc:a1f83881f9acd476313c652f53b57d7cc"><td class="mdescLeft">&#160;</td><td class="mdescRight">The key in our config file to find the root of speaker manager configuration.  <a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html#a1f83881f9acd476313c652f53b57d7cc">More...</a><br /></td></tr>
<tr class="separator:a1f83881f9acd476313c652f53b57d7cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a18b0fbb623c22765693c76224c360f83"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html#a18b0fbb623c22765693c76224c360f83">alexaClientSDK::capabilityAgents::speakerManager::SPEAKERMANAGER_MIN_UNMUTE_VOLUME_KEY</a> = &quot;minUnmuteVolume&quot;</td></tr>
<tr class="memdesc:a18b0fbb623c22765693c76224c360f83"><td class="mdescLeft">&#160;</td><td class="mdescRight">The key in our config file to find the minUnmuteVolume value.  <a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html#a18b0fbb623c22765693c76224c360f83">More...</a><br /></td></tr>
<tr class="separator:a18b0fbb623c22765693c76224c360f83"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="ad8bc9ca8e55a0ebf538e46e28bf26262"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad8bc9ca8e55a0ebf538e46e28bf26262">&#9670;&nbsp;</a></span>LX</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define LX</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">event</td><td>)</td>
          <td>&#160;&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">alexaClientSDK::avsCommon::utils::logger::LogEntry</a>(<a class="el" href="_u_i_manager_8cpp.html#ada5473a95becdcf63a8f83e7f05fefe7">TAG</a>, event)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Create a LogEntry using this file's TAG and the specified event string.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">The</td><td>event string for this <code>LogEntry</code>. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
